<?php

echo "<html>
<head>
<title>wtGuestbook Installation</title>
<style type=\"text/css\">
html, body {
margin: 0px;
padding: 0px;
border: 0px none;
font-face: Trebuchet,Arial,Verdana,Helvetica;
font-size: 11pt;
background-color: #475789;
}
a {
color: white;
}
table, th, td {
background-color: #C7DBFE;
}
.install {
margin-top: 15px;
margin-left: 15px;
margin-right: auto;
width: 80%;
}
</style>
</head>
<body>
<div class=\"install\">";

if(file_exists('./install.lock')) die('install.lock lschen!');

if(!function_exists('file_put_contents')){
	function file_put_contents($filename, $data, $respect_lock = true){
		$fh = @fopen($filename, 'w');
		if($fh===false) return false;
		if(($respect_lock===true)&&(!flock($fh, LOCK_EX))){
			fclose($fh);
			return false;
		}
		if(is_array($data)) $data = implode('', $data);
		else $data = (string) $data;
		$bytes = fwrite($fh, $data);
		fclose($fh);
		return $bytes;
	}
}

function unzip($src_file, $dest_dir=false, $create_zip_name_dir=true, $overwrite=true){
	if(function_exists("zip_open")){
		if(!is_resource(@zip_open($src_file))) $src_file=dirname($_SERVER['SCRIPT_FILENAME']).'/'.$src_file;
		if(is_resource($zip = zip_open($src_file))){
			$splitter = ($create_zip_name_dir===true)?'.':'/';
			if($dest_dir===false) $dest_dir = substr($src_file, 0, strrpos($src_file, $splitter)).'/';
			create_dirs($dest_dir);
			while($zip_entry = zip_read($zip)){
 				$pos_last_slash = strrpos(zip_entry_name($zip_entry), '/');
				if($pos_last_slash!==false){
					create_dirs($dest_dir.substr(zip_entry_name($zip_entry), 0, $pos_last_slash+1));
				}
				if(zip_entry_open($zip,$zip_entry,"r")){
 					$file_name = $dest_dir.zip_entry_name($zip_entry);
      					if(($overwrite===true)||($overwrite===false)&&(!is_file($file_name))){
 						$fstream = @zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));
						if(!is_dir($file_name)) file_put_contents($file_name, $fstream);
						if(file_exists($file_name)){
							@chmod($file_name, 0777);
						}else{
							die("ERROR!!!! FILE NOT FOUND");
						}
					}
					zip_entry_close($zip_entry);
				}      
			}
			zip_close($zip);
		}else{
			die("ERROR!!!! ZIP FILE NOT FOUND");
			return false;
		}
		return true;
	}else{
		die("ERROR!!!! ZIP LIB NOT FOUND<br /><br />Weitere Infos im offiziellen FAQ: <a href=\"http://www.wondertown.de/index.php?action=show&show=faq#2.1\">http://www.wondertown.de/index.php?action=show&show=faq#2.1</a>");
	}
}

function create_dirs($path){
	if(!is_dir($path)){
		$directory_path = '';
		$directories = explode('/', $path);
		array_pop($directories);
		foreach($directories as $directory){
			$directory_path.= $directory.'/';
			if(!is_dir($directory_path)){
				@mkdir($directory_path);
				@chmod($directory_path, 0777);
			}
		}
	}
}

function split_sql($query){
	$query = trim($query);
	$query = ereg_replace('\n#[^\n]*\n', '\n', $query);
	$temp = array();
	$return = array();
	$in_string = false;
	for($i=0; $i<strlen($query)-1; $i++){
		if($query[$i] == ';' && !$in_string){
			$return[] = substr($query, 0, $i);
			$query = substr($query, $i+1);
			$i = 0;
		}
		if($in_string&&($query[$i]==$in_string)&&$temp[1]!='\\') $in_string = false;
		elseif(!$in_string&&($query[$i]=='"'||$query[$i]=='\'')&&(!isset($temp[0])||$temp[0] != '\\')) $in_string = $query[$i];
		if(isset($temp[1])) $temp[0] = $temp[1];
		$temp[1] = $query[$i];
	}
	if(!empty($query)) $return[] = $query;
	return($return);
}



$step = ((isset($_GET['step']))&&($_GET['step']!='')) ? $_GET['step'] : '';

if($step==''){
	$error = 0;
	if(version_compare(phpversion(), '4.3.0', '<')){
		$phpcolor = "red";
		$error++;
	}else $phpcolor = "limegreen";
	$moretds.='<tr>
<td style="background-color: '.$phpcolor.'">PHP-Version</td>
<td style="background-color: '.$phpcolor.'">4.3.0</td>
<td style="background-color: '.$phpcolor.'">'.phpversion().'</td>
</tr>';
//	if(function_exists("zip_open")){
//		$ziplibcolor = "limegreen";
//		$ziplibyn = "Ja";
//	}else{
//		$ziplibcolor = "red";
//		$ziplibyn = "Nein";
//		$error++;
//	}
		$ziplibcolor = "yellow";
		$ziplibyn = "Unbekannt (Eventuell auftretende Fehler bitte im <a href=\"http://forum.wondertown.de\">Supportforum</a> melden!)";
	$moretds.='<tr>
<td style="background-color: '.$ziplibcolor.'">ZIP Extension aktiviert</td>
<td style="background-color: '.$ziplibcolor.'">Ja</td>
<td style="background-color: '.$ziplibcolor.'">'.$ziplibyn.'</td>
</tr>';
	if(file_exists('./install.zip')){
		$installfilecolor = "limegreen";
		$installfileyn = "Ja";
	}else{
		$installfilecolor = "red";
		$installfileyn = "Nein";
		$error++;
	}
	$moretds.='<tr>
<td style="background-color: '.$installfilecolor.'">Installations ZIP-Archiv vorhanden</td>
<td style="background-color: '.$installfilecolor.'">Ja</td>
<td style="background-color: '.$installfilecolor.'">'.$installfileyn.'</td>
</tr>';
	if(file_exists('./install.lock')){
		$installlockcolor = "red";
		$installlockyn = "Ja";
		$error++;
	}else{
		$installlockcolor = "limegreen";
		$installlockyn = "Nein";
	}
	$moretds.='<tr>
<td style="background-color: '.$installlockcolor.'">install.lock vorhanden</td>
<td style="background-color: '.$installlockcolor.'">Nein</td>
<td style="background-color: '.$installlockcolor.'">'.$installlockyn.'</td>
</tr>';
	if($error==0){
		$moretds.='<tr>
<td colspan="3"><a href="./install.php?step=unzip">Installation starten</a></td>
</tr>';
	}else{
		$moretds.='<tr>
<td colspan="3">Die Installation kann nicht gestartet werden, solange nicht alle Anforderungen erfllt sind.</td>
</tr>';
	}
	echo '<table border="1" bordercolor="black" cellspacing="0" cellpadding="3">
<tr>
<th>&nbsp;</th>
<th align="left">Erforderlich</th>
<th align="left">Vorhanden</th>
</tr>
'.$moretds.'
</table>';
}

if($step=='unzip'){
	unzip('./install.zip', false, false, false);
	echo 'Die Dateien wurden erfolgreich entpackt!<br /><a href="./install.php?step=sql">Zur Datenbankeinrichtung</a>';
}

if($step=='sql'){
	require_once('./config.inc.php');
	echo '<center><form action="install.php?step=sql2" method="post">
  <table border=1 bordercolor="#000000" cellspacing="0">
  <tr><td><br><center>Datenbank-Einrichtung</center><br></td></tr><tr><td>
<br>
<center>
<table>
<tr>
<td align="left">MySQL Host:</td>
<td align="left"><input type="text" name="sqlhost" value="'.$host.'"></td>
</tr>
<tr>
<td align="left">MySQL Benutzer:</td>
<td align="left"><input type="text" name="sqluser" value="'.$user.'"></td>
</tr>
<tr>
<td align="left">MySQL Passwort:</td>
<td align="left"><input type="text" name="sqlpass" value="'.$pass.'"></td>
</tr>
<tr>
<td align="left">MySQL Datenbank:</td>
<td align="left"><input type="text" name="sqldatabase" value="'.$database.'"></td>
</tr>
<tr>
<td align="left">Installationsnummer:</td>
<td align="left"><input type="text" name="sqlinstall" value="'.$n.'"></td>
</tr>
</table>
<input type="submit" value="Weiter"></center><br>
</td>
</tr>
</table>
</form></center>';
}

if($step=='sql2'){
	require_once('./config.inc.php');
	require_once('./class_mysql.php');
	$data = '<?php
//Datenbankverbindung
//Host
$host=\''.$_POST['sqlhost'].'\';
//DB User
$user=\''.$_POST['sqluser'].'\';
//DB Passwort
$pass=\''.$_POST['sqlpass'].'\';
//Datenbank
$database=\''.$_POST['sqldatabase'].'\';
//Installationsnummer (Standard: 1)
$n=\''.$_POST['sqlinstall'].'\';
?>';
	$fp = fopen('./config.inc.php', 'w+');
	fputs($fp, $data);
	fclose($fp);
	$sql = &new wt_mysql($_POST['sqlhost'], $_POST['sqluser'], $_POST['sqlpass'], $_POST['sqldatabase']);
	echo 'Die MySQL-Daten wurden erfolgreich getestet und gespeichert!<br /><a href="./install.php?step=sql3">Datenbank installieren</a>';
}

if($step=='sql3'){
	require_once('./config.inc.php');
	require_once('./class_mysql.php');
	$sql = &new wt_mysql($host, $user, $pass, $database);
	$setupfile = implode('',file('./setup.sql'));
	if($n!=1) $setupfile = str_replace('wtg1', 'wtg'.$n, $setupfile);
	foreach(split_sql($setupfile) as $value) $sql->query($value);
	$gurl = substr($_SERVER['HTTP_REFERER'], 0, strrpos($_SERVER['HTTP_REFERER'], '/'));
	$sql->query("update wtg".$n."_options set gburl='$gurl'");
	$res = $sql->query("select * from wtg".$n."_options",0);
	$rum = $sql->num_rows($res);
	if($rum!=0){
		while($row = $sql->fetch_array($res)){
			$content = '<?php ';
			foreach($row as $key=>$value){
				if(!is_int($key)){
					$value = str_replace('\'', '\\\'', $value);
					$content.=' $'.$key.' = \''.$value.'\'; ';
				}
			}
			$content.= '?>';
			if(!@file_exists($cache.'/options.php')) $open_mode = 'x';
			else $open_mode = 'w';
			$handle = @fopen($cache.'/options.php', $open_mode);
			@fwrite($handle, trim($content));
			@fclose($handle);
			$sql->query("update wtg".$n."_options set lc_options = UNIX_TIMESTAMP()");
		}
	}
	echo 'Die Datenbank wurde erfolgreich installiert!<br /><a href="./install.php?step=finish">Installation abschlieen</a>';
}

if($step=='finish'){
	$fp = fopen('./install.lock', 'w+');
	fputs($fp, '');
	fclose($fp);
	echo 'Die Installation war erfolgreich.<br />Loggen Sie sich im <a href="./acc.php">Admin Control Center</a> ein und nehmen Sie Einstellungen vor.';
}

echo "</div>
</body>
</html>";

?>